package com.therealbluepandabear.pixapencil.activities.canvas

import com.therealbluepandabear.pixapencil.algorithms.*

fun CanvasActivity.initPrimaryAlgorithmInfoParameter() {
    primaryAlgorithmInfoParameter = AlgorithmInfoParameter.create(
        canvasCommandsHelperInstance,
        binding.activityCanvasPixelGridView.pixelGridViewBitmap,
        viewModel.currentBitmapAction!!,
        getSelectedColor()
    )

    lineAlgorithm = LineAlgorithm(primaryAlgorithmInfoParameter)
    circleAlgorithm = CircleAlgorithm(primaryAlgorithmInfoParameter)
    filledCircleAlgorithm = CircleAlgorithm(primaryAlgorithmInfoParameter, filledMode = true)
    ellipseAlgorithm = EllipseAlgorithm(primaryAlgorithmInfoParameter)
    filledEllipseAlgorithm = EllipseAlgorithm(primaryAlgorithmInfoParameter, filledMode = true)
    rectangleAlgorithm = RectangleAlgorithm(primaryAlgorithmInfoParameter)
    visibleRectanglePreviewAlgorithm = RectanglePreviewAlgorithm(primaryAlgorithmInfoParameter, false)
    visibleSquarePreviewAlgorithm = SquarePreviewAlgorithm(primaryAlgorithmInfoParameter, invisibleMode = false)
    invisibleRectanglePreviewAlgorithm = RectanglePreviewAlgorithm(primaryAlgorithmInfoParameter, invisibleMode = true)
    filledRectangleAlgorithm = RectangleAlgorithm(primaryAlgorithmInfoParameter)
    invisibleSquarePreviewAlgorithm = SquarePreviewAlgorithm(primaryAlgorithmInfoParameter, invisibleMode = true)
}