package com.therealbluepandabear.pixapencil.extensions

import android.app.Activity
import android.content.DialogInterface
import android.view.View
import com.google.android.material.dialog.MaterialAlertDialogBuilder
import com.therealbluepandabear.pixapencil.R

fun Activity.showDialogWithNeutralButtonAndOnCancelListener(
    dialogTitle: String,
    dialogMessage: String?,
    dialogPositiveButtonText: String,
    dialogPositiveButtonAction: DialogInterface.OnClickListener,
    dialogNegativeButtonText: String?,
    dialogNegativeButtonAction: DialogInterface.OnClickListener?,
    dialogNeutralButtonText: String,
    dialogNeutralButtonAction: DialogInterface.OnClickListener?,
    dialogOnCancelListener: DialogInterface.OnCancelListener?,
    view: View? = null) {
    MaterialAlertDialogBuilder(this, R.style.ThemeOverlay_App_MaterialAlertDialog)
        .setTitle(dialogTitle)
        .setMessage(dialogMessage)
        .setView(view)
        .setPositiveButton(dialogPositiveButtonText, dialogPositiveButtonAction)
        .setNegativeButton(dialogNegativeButtonText, dialogNegativeButtonAction)
        .setNeutralButton(dialogNeutralButtonText, dialogNeutralButtonAction)
        .setOnCancelListener(dialogOnCancelListener)
        .show()
}

fun Activity.showSimpleInfoDialog(
    dialogTitle: String,
    dialogMessage: String) {
    MaterialAlertDialogBuilder(this, R.style.ThemeOverlay_App_MaterialAlertDialog)
        .setTitle(dialogTitle)
        .setMessage(dialogMessage)
        .setPositiveButton(getString(R.string.generic_ok), null)
        .show()
}